//-----------------------------------------------------------------------------
// 
// 		cwCu		Androidp}XNf[^ǗvO
// 
//  	Ver 3.18c
// 
//-----------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

#include "../DxCompileConfig.h"

#ifndef DX_NON_MASK

// CN[h ---------------------------------------------------------------
#include "DxGraphicsAndroid.h"
#include "DxMaskAndroid.h"
#include "../DxModel.h"
#include "../DxSystem.h"
#include "../DxLog.h"
#include "../DxMask.h"
#include "../DxMemory.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` -----------------------------------------------------------------

// \̐錾 -----------------------------------------------------------------

// f[^` -----------------------------------------------------------------

MASKMANAGEDATA_ANDR MaskManageData_Android ;

// ֐錾 -------------------------------------------------------------------

// vO -----------------------------------------------------------------

// ˑ֐

// }XNXN[쐬֐
extern	int			Mask_CreateScreenFunction_Timing0_PF( void )
{
	MASKANDR.MaskScreenOldFrameBuffer   = MASKANDR.MaskScreenFrameBuffer ;
	MASKANDR.MaskScreenOldTextureBuffer = MASKANDR.MaskScreenTextureBuffer ;
	MASKANDR.MaskScreenOldDepthBuffer   = MASKANDR.MaskScreenDepthBuffer ;

	if( MASKANDR.MaskImageTextureBuffer != 0 )
	{
		glDeleteTextures( 1, &MASKANDR.MaskImageTextureBuffer ) ;
		MASKANDR.MaskImageTextureBuffer = 0 ;
	}

	// I
	return 0 ;
}

// }XNXN[쐬֐
extern	int			Mask_CreateScreenFunction_Timing1_PF( int Width, int Height )
{
	MASKANDR.MaskTextureSizeX = Width ;
	MASKANDR.MaskTextureSizeY = Height ;

	// }XNpC[WeNX`̍쐬
	if( MASKANDR.MaskImageTextureBuffer == 0 )
	{
		PIXELFORMAT_INFO_ANDR *PixelFormat ;

		PixelFormat = &g_AndroidPixelFormat[ GANDR.Device.Caps.MaskAlphaFormat ] ;
		glGenTextures( 1, &MASKANDR.MaskImageTextureBuffer ) ;
		glActiveTexture( GL_TEXTURE0 ) ;
		glBindTexture( GL_TEXTURE_2D, MASKANDR.MaskImageTextureBuffer ) ;

		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST ) ;
		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST ) ;

		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE ) ;
		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE ) ;

		if( PixelFormat->IsExtFormat )
		{
			glCompressedTexImage2D(
				GL_TEXTURE_2D,
				0,
				PixelFormat->InternalFormat,
				MASKANDR.MaskTextureSizeX,
				MASKANDR.MaskTextureSizeY,
				0,
				0,
				0
			) ;
		}
		else
		{
			glTexImage2D(
				GL_TEXTURE_2D,
				0,
				PixelFormat->InternalFormat,
				MASKANDR.MaskTextureSizeX,
				MASKANDR.MaskTextureSizeY,
				0,
				PixelFormat->Format,
				PixelFormat->Type,
				0
			) ;
		}

		// }XNpC[W̓]
		{
			RECT SrcRect ;
			RECT DestRect ;
			BASEIMAGE MaskBaseImage ;
			BASEIMAGE AlphaBaseImage ;

			SrcRect.left   = 0 ;
			SrcRect.top    = 0 ;
			SrcRect.right  = MASKANDR.MaskTextureSizeX ;
			SrcRect.bottom = MASKANDR.MaskTextureSizeY ;
			DestRect = SrcRect ;

			_MEMSET( &AlphaBaseImage, 0, sizeof( AlphaBaseImage ) ) ;
			MaskBaseImage.ColorData			= *Graphics_Android_GetDataFormatColorData( GANDR.Device.Caps.MaskAlphaFormat ) ;
			MaskBaseImage.Width				= MASKANDR.MaskTextureSizeX ;
			MaskBaseImage.Height			= MASKANDR.MaskTextureSizeY ;
			MaskBaseImage.Pitch				= MASKD.MaskBufferPitch ;
			MaskBaseImage.GraphData			= MASKD.MaskBuffer ;
			MaskBaseImage.MipMapCount		= 0 ;
			MaskBaseImage.GraphDataCount	= 0 ;

			Graphics_Android_BltBmpOrBaseImageToGraph3_NoMipMapBlt(
				&SrcRect,
				&DestRect,
				MASKANDR.MaskImageTextureBuffer,
				1,
				MASKANDR.MaskTextureSizeX,
				MASKANDR.MaskTextureSizeY,
				MASKANDR.MaskTextureSizeX,
				MASKANDR.MaskTextureSizeY,
				&MaskBaseImage,
				&AlphaBaseImage,
				GANDR.Device.Caps.MaskAlphaFormat,
				FALSE,
				FALSE,
				0,
				FALSE
			) ;
		}
	}

	// }XNpXN[eNX`̍쐬
	if( MASKANDR.MaskScreenFrameBuffer == 0 )
	{
		// Offscreen position framebuffer texture target
		glGenTextures( 1, &MASKANDR.MaskScreenTextureBuffer ) ;
		glActiveTexture( GL_TEXTURE0 ) ;
		glBindTexture( GL_TEXTURE_2D, MASKANDR.MaskScreenTextureBuffer ) ;
		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE ) ;
		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE ) ;
		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR ) ;
		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR ) ;
		glTexImage2D( GL_TEXTURE_2D, 0, GL_RGB, MASKANDR.MaskTextureSizeX, MASKANDR.MaskTextureSizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, 0 ) ;

		glGenFramebuffers( 1, &MASKANDR.MaskScreenFrameBuffer ) ;
		glBindFramebuffer( GL_FRAMEBUFFER, MASKANDR.MaskScreenFrameBuffer ) ;

		// _[obt@ʎq𐶐܂B
		glGenRenderbuffers( 1, &MASKANDR.MaskScreenDepthBuffer ) ;

		// _[obt@ʎqɑΉ_[obt@IuWFNg𐶐܂B
		glBindRenderbuffer( GL_RENDERBUFFER, MASKANDR.MaskScreenDepthBuffer ) ;

		// _[obt@̕ƍw肵܂B
		glRenderbufferStorage( GL_RENDERBUFFER, GL_DEPTH_COMPONENT16, MASKANDR.MaskTextureSizeX, MASKANDR.MaskTextureSizeY ) ;

		// t[obt@̃A^b`gƂă_[obt@A^b`܂B
		glFramebufferRenderbuffer( GL_FRAMEBUFFER, GL_DEPTH_ATTACHMENT, GL_RENDERBUFFER, MASKANDR.MaskScreenDepthBuffer ) ;

		// t[obt@̃A^b`gƂ 2D eNX`A^b`܂B
		glFramebufferTexture2D( GL_FRAMEBUFFER, GL_COLOR_ATTACHMENT0, GL_TEXTURE_2D, MASKANDR.MaskScreenTextureBuffer, 0 ) ;

		// t[obt@Sǂ`FbN܂B
		GLint status = glCheckFramebufferStatus( GL_FRAMEBUFFER ) ;
		if( status != GL_FRAMEBUFFER_COMPLETE )
		{
			DXST_LOGFILE_ADDUTF16LE( "\xde\x30\xb9\x30\xaf\x30\x28\x75\xd5\x30\xec\x30\xfc\x30\xe0\x30\xd0\x30\xc3\x30\xd5\x30\xa1\x30\x6e\x30\x5c\x4f\x10\x62\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x0a\x00\x00"/*@ L"}XNpt[obt@̍쐬Ɏs܂\n" @*/ ) ;
			return -1 ;
		}
		glBindFramebuffer( GL_FRAMEBUFFER, 0 ) ;
	}

	// I
	return 0 ;
}

// }XNXN[쐬֐
extern	int			Mask_CreateScreenFunction_Timing2_PF( int MaskBufferSizeXOld, int MaskBufferSizeYOld )
{
	RECT UpdateRect ;

	// `IĂ
	Graphics_Android_RenderEnd() ;

	// }XNpC[W̓]
	{
		RECT SrcRect ;
		RECT DestRect ;
		BASEIMAGE MaskBaseImage ;
		BASEIMAGE AlphaBaseImage ;

		SrcRect.left   = 0 ;
		SrcRect.top    = 0 ;
		SrcRect.right  = MASKANDR.MaskTextureSizeX ;
		SrcRect.bottom = MASKANDR.MaskTextureSizeY ;
		DestRect = SrcRect ;

		_MEMSET( &AlphaBaseImage, 0, sizeof( AlphaBaseImage ) ) ;
		MaskBaseImage.ColorData			= *Graphics_Android_GetDataFormatColorData( GANDR.Device.Caps.MaskAlphaFormat ) ;
		MaskBaseImage.Width				= MASKANDR.MaskTextureSizeX ;
		MaskBaseImage.Height			= MASKANDR.MaskTextureSizeY ;
		MaskBaseImage.Pitch				= MASKD.MaskBufferPitch ;
		MaskBaseImage.GraphData			= MASKD.MaskBuffer ;
		MaskBaseImage.MipMapCount		= 0 ;
		MaskBaseImage.GraphDataCount	= 0 ;

		Graphics_Android_BltBmpOrBaseImageToGraph3_NoMipMapBlt(
			&SrcRect,
			&DestRect,
			MASKANDR.MaskImageTextureBuffer,
			1,
			MASKANDR.MaskTextureSizeX,
			MASKANDR.MaskTextureSizeY,
			MASKANDR.MaskTextureSizeX,
			MASKANDR.MaskTextureSizeY,
			&MaskBaseImage,
			&AlphaBaseImage,
			GANDR.Device.Caps.MaskAlphaFormat,
			FALSE,
			FALSE,
			0,
			FALSE
		) ;
	}

	// }XNpXN[eNX`ɍ܂ł̓e]
	UpdateRect.left   = 0 ;
	UpdateRect.top    = 0 ;
	UpdateRect.right  = MaskBufferSizeXOld ;
	UpdateRect.bottom = MaskBufferSizeYOld ;
	Graphics_Android_StretchRect(
		MASKANDR.MaskScreenOldTextureBuffer, MaskBufferSizeXOld,        MaskBufferSizeYOld,        &UpdateRect,
		MASKANDR.MaskScreenFrameBuffer,      MASKANDR.MaskTextureSizeX, MASKANDR.MaskTextureSizeY, &UpdateRect
	) ;

	// _[^[QbgɂĂύX
	if( GANDR.Device.State.TargetFrameBuffer == MASKANDR.MaskScreenOldFrameBuffer )
	{
		Graphics_Android_DeviceState_SetRenderTarget( MASKANDR.MaskScreenFrameBuffer, MASKANDR.MaskTextureSizeX, MASKANDR.MaskTextureSizeY ) ;
	}

	// ȑÕ}XNXN[J
	{
		if( MASKANDR.MaskScreenOldFrameBuffer != 0 )
		{
			glDeleteFramebuffers( 1, &MASKANDR.MaskScreenOldFrameBuffer ) ;
			MASKANDR.MaskScreenOldFrameBuffer = 0 ;
		}

		if( MASKANDR.MaskScreenOldTextureBuffer != 0 )
		{
			glDeleteTextures( 1, &MASKANDR.MaskScreenOldTextureBuffer ) ;
			MASKANDR.MaskScreenOldTextureBuffer = 0 ;
		}

		if( MASKANDR.MaskScreenOldDepthBuffer != 0 )
		{
			glDeleteRenderbuffers( 1, &MASKANDR.MaskScreenOldDepthBuffer ) ;
			MASKANDR.MaskScreenOldDepthBuffer = 0 ;
		}
	}

	// I
	return 0 ;
}

// }XNXN[ꎞ폜
extern	int			Mask_ReleaseSurface_PF( void )
{
	if( MASKANDR.MaskImageTextureBuffer != 0 )
	{
		glDeleteTextures( 1, &MASKANDR.MaskImageTextureBuffer ) ;
		MASKANDR.MaskImageTextureBuffer = 0 ;
	}

	if( MASKANDR.MaskScreenFrameBuffer != 0 )
	{
		glDeleteFramebuffers( 1, &MASKANDR.MaskScreenFrameBuffer ) ;
		MASKANDR.MaskScreenFrameBuffer = 0 ;
	}

	if( MASKANDR.MaskScreenTextureBuffer != 0 )
	{
		glDeleteTextures( 1, &MASKANDR.MaskScreenTextureBuffer ) ;
		MASKANDR.MaskScreenTextureBuffer = 0 ;
	}

	if( MASKANDR.MaskScreenDepthBuffer != 0 )
	{
		glDeleteRenderbuffers( 1, &MASKANDR.MaskScreenDepthBuffer ) ;
		MASKANDR.MaskScreenDepthBuffer = 0 ;
	}

	return 0 ;
}

// }XNgp[hύX
extern	int			Mask_SetUseMaskScreenFlag_PF( void )
{
	IMAGEDATA     *Image     = NULL ;
	SHADOWMAPDATA *ShadowMap = NULL ;

	// `̉摜f[^AhX擾
	if( GSYS.DrawSetting.ShadowMapDrawSetupRequest )
	{
		ShadowMap = Graphics_ShadowMap_GetData( GSYS.DrawSetting.ShadowMapDrawHandle ) ;
	}
	else
	{
		Image = Graphics_Image_GetData( GSYS.DrawSetting.TargetScreen[ 0 ] ) ;
	}

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// `I
	Graphics_Android_RenderEnd() ;

	// `ύX

	// }XNT[tFX݂ĂĊLȏꍇ̓}XNT[tFX`Ώۂɂ
	if( MASKD.MaskValidFlag && MASKANDR.MaskScreenFrameBuffer )
	{
		Graphics_Android_DeviceState_SetRenderTarget( MASKANDR.MaskScreenFrameBuffer, MASKANDR.MaskTextureSizeX, MASKANDR.MaskTextureSizeY ) ;
	}
	else
	// VhE}bvLȏꍇ̓VhE}bv`Ώۂɂ
	if( ShadowMap )
	{
		Graphics_Android_DeviceState_SetRenderTarget( ShadowMap->PF->FrameBuffer, ShadowMap->PF->Texture.Width, ShadowMap->PF->Texture.Height ) ;
	}
	else
	// `\摜Lȏꍇ͕`\摜`Ώۂɂ
	if( Image )
	{
		if( Image->Hard.Draw[ 0 ].Tex->PF->MSRenderTarget != 0 )
		{
			Graphics_Android_DeviceState_SetRenderTarget( Image->Hard.Draw[ 0 ].Tex->PF->MSRenderTarget, Image->Hard.Draw[ 0 ].Tex->PF->Texture.Width, Image->Hard.Draw[ 0 ].Tex->PF->Texture.Height ) ;
		}
		else
		{
			Graphics_Android_DeviceState_SetRenderTarget( Image->Hard.Draw[ 0 ].Tex->PF->FrameBuffer, Image->Hard.Draw[ 0 ].Tex->PF->Texture.Width, Image->Hard.Draw[ 0 ].Tex->PF->Texture.Height ) ;
		}
	}
	else
	// ȊȌꍇ̓TuobNobt@`Ώۂɂ
	{
		Graphics_Android_DeviceState_SetRenderTarget( GANDR.Device.Screen.SubBackBufferFrameBuffer, GANDR.Device.Screen.SubBackBufferTextureSizeX, GANDR.Device.Screen.SubBackBufferTextureSizeY ) ;
	}

	// gpyobt@̃ZbgAbv
	Graphics_Screen_SetupUseZBuffer() ;

	// r[|[gɖ߂
	GANDR.Device.DrawSetting.CancelSettingEqualCheck = TRUE ;
	Graphics_Android_DeviceState_SetViewportEasy(
		GSYS.DrawSetting.DrawArea.left,
		GSYS.DrawSetting.DrawArea.top,
		GSYS.DrawSetting.DrawArea.right,
		GSYS.DrawSetting.DrawArea.bottom
	) ;
	GANDR.Device.DrawSetting.CancelSettingEqualCheck = FALSE ;

	// I
	return 0 ;
}

// }XNgp`̑OɌĂԊ֐( łɃTuobt@gp`GA@\gpĂꍇ̏Ă܂Ă )
extern	int			Mask_DrawBeginFunction_PF( RECT *Rect )
{
	IMAGEDATA     *Image     = NULL ;
	SHADOWMAPDATA *ShadowMap = NULL ;

	// `̉摜f[^AhX擾
	if( GSYS.DrawSetting.ShadowMapDraw == FALSE )
	{
		ShadowMap = Graphics_ShadowMap_GetData( GSYS.DrawSetting.ShadowMapDrawHandle ) ;
	}
	else
	{
		Image = Graphics_Image_GetData( GSYS.DrawSetting.TargetScreen[ 0 ] ) ;
	}

	// }XNgpĂƂ̂ݓʂȏ
	if( MASKD.MaskValidFlag && MASKANDR.MaskScreenFrameBuffer )
	{
		// ŏIo͐̌
		
		// `\摜`̏ꍇ͂AȊȌꍇ̓TuobNobt@gpĂꍇ̓TuobNobt@A
		// ł͂Ȃꍇ̓obNobt@o͐ɂ
		if( ShadowMap )
		{
			MASKANDR.DestTargetTextureBuffer = ShadowMap->PF->Texture.TextureBuffer ;
			MASKANDR.DestTargetFrameBuffer   = ShadowMap->PF->FrameBuffer ;
			MASKANDR.DestTargetWidth         = ShadowMap->PF->Texture.Width ;
			MASKANDR.DestTargetHeight        = ShadowMap->PF->Texture.Height ;
		}
		else
		if( Image )
		{
			MASKANDR.DestTargetTextureBuffer = Image->Hard.Draw[ 0 ].Tex->PF->Texture.TextureBuffer ;
			if( Image->Hard.Draw[ 0 ].Tex->PF->MSRenderTarget != 0 )
			{
				MASKANDR.DestTargetFrameBuffer = Image->Hard.Draw[ 0 ].Tex->PF->MSRenderTarget ;
			}
			else
			{
				MASKANDR.DestTargetFrameBuffer = Image->Hard.Draw[ 0 ].Tex->PF->FrameBuffer ;
			}
			MASKANDR.DestTargetWidth  = Image->Hard.Draw[ 0 ].Tex->PF->Texture.Width ;
			MASKANDR.DestTargetHeight = Image->Hard.Draw[ 0 ].Tex->PF->Texture.Height ;
		}
		else
		{
			MASKANDR.DestTargetTextureBuffer = GANDR.Device.Screen.SubBackBufferTexture ;
			MASKANDR.DestTargetFrameBuffer   = GANDR.Device.Screen.SubBackBufferFrameBuffer ;
			MASKANDR.DestTargetWidth         = GANDR.Device.Screen.SubBackBufferTextureSizeX ;
			MASKANDR.DestTargetHeight        = GANDR.Device.Screen.SubBackBufferTextureSizeY ;
		}

		// ŏIo͐悩}XNXN[Ɍ݂̕`󋵂Rs[
		Graphics_Android_StretchRect(
			MASKANDR.DestTargetTextureBuffer, MASKANDR.DestTargetWidth,  MASKANDR.DestTargetHeight, Rect,
			MASKANDR.MaskScreenFrameBuffer,   MASKANDR.MaskTextureSizeX, MASKANDR.MaskTextureSizeY, Rect
		) ; 
	}

	// I
	return 0 ;
}

// }XNgp`̌ɌĂԊ֐( łɃTuobt@gp`GA@\gpĂꍇ̏Ă܂Ă )
extern	int			Mask_DrawAfterFunction_PF( RECT *Rect )
{
	// }XNgpĂꍇ̂݃}XN摜ƍē]
	if( MASKD.MaskValidFlag && MASKANDR.MaskScreenFrameBuffer )
	{
		IMAGEDATA               *MaskScreenImage = NULL ;
		GLuint                  MaskImageTextureBuffer ;
		int						MaskImageTextureWidth ;
		int						MaskImageTextureHeight ;
		GRAPHICS_ANDROID_SHADER *MaskShader ;
		int                     AlphaBlend ;

		// }XNpOtBbNnhLȏꍇ̓}XNpOtBbNnh̏擾
		if( MASKD.MaskScreenGraphHandle != 0 )
		{
			MaskScreenImage = Graphics_Image_GetData( MASKD.MaskScreenGraphHandle ) ;

			// ɖɂȂĂݒ 0 ɂ
			if( MaskScreenImage == NULL )
			{
				MASKD.MaskScreenGraphHandle = 0 ;
			}
		}

		// gp}XNC[WeNX`Zbg
		if( MaskScreenImage != NULL )
		{
			MaskImageTextureBuffer = MaskScreenImage->Hard.Draw[ 0 ].Tex->PF->Texture.TextureBuffer ;
			MaskImageTextureWidth  = MaskScreenImage->Hard.Draw[ 0 ].Tex->PF->Texture.Width ;
			MaskImageTextureHeight = MaskScreenImage->Hard.Draw[ 0 ].Tex->PF->Texture.Height ;
			MaskShader     = MASKD.MaskReverseEffectFlag ?
				&GANDR.Device.Shader.Base.MaskEffect_UseGraphHandle_ReverseEffect_Shader[ MASKD.MaskScreenGraphHandleUseChannel ] :
				&GANDR.Device.Shader.Base.MaskEffect_UseGraphHandle_Shader[ MASKD.MaskScreenGraphHandleUseChannel ] ;
			AlphaBlend             = TRUE ;
		}
		else
		{
			MaskImageTextureBuffer = MASKANDR.MaskImageTextureBuffer ;
			MaskImageTextureWidth  = MASKANDR.MaskTextureSizeX ;
			MaskImageTextureHeight = MASKANDR.MaskTextureSizeY ;
			MaskShader             = MASKD.MaskReverseEffectFlag ? &GANDR.Device.Shader.Base.MaskEffect_ReverseEffect_Shader : &GANDR.Device.Shader.Base.MaskEffect_Shader ;
			AlphaBlend             = FALSE ;
		}

		Graphics_Android_StretchRect(
			MASKANDR.MaskScreenTextureBuffer, MASKANDR.MaskTextureSizeX, MASKANDR.MaskTextureSizeY, Rect,
			MASKANDR.DestTargetFrameBuffer,   MASKANDR.DestTargetWidth,  MASKANDR.DestTargetHeight, Rect,
			GL_NEAREST,
			AlphaBlend,
			MaskShader,
			MaskImageTextureBuffer,           MaskImageTextureWidth,     MaskImageTextureHeight,    Rect
		) ;
	}

	return 0 ;
}

// }XNXN[w̐FœhԂ
extern	int			Mask_FillMaskScreen_PF( int Flag )
{
//	int i ;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// `I
	Graphics_Android_RenderEnd() ;

	// }XNpC[W̓]
	{
		RECT SrcRect ;
		RECT DestRect ;
		BASEIMAGE MaskBaseImage ;
		BASEIMAGE AlphaBaseImage ;

		SrcRect.left   = 0 ;
		SrcRect.top    = 0 ;
		SrcRect.right  = MASKANDR.MaskTextureSizeX ;
		SrcRect.bottom = MASKANDR.MaskTextureSizeY ;
		DestRect = SrcRect ;

		_MEMSET( &AlphaBaseImage, 0, sizeof( AlphaBaseImage ) ) ;
		MaskBaseImage.ColorData			= *Graphics_Android_GetDataFormatColorData( GANDR.Device.Caps.MaskAlphaFormat ) ;
		MaskBaseImage.Width				= MASKANDR.MaskTextureSizeX ;
		MaskBaseImage.Height			= MASKANDR.MaskTextureSizeY ;
		MaskBaseImage.Pitch				= MASKD.MaskBufferPitch ;
		MaskBaseImage.GraphData			= MASKD.MaskBuffer ;
		MaskBaseImage.MipMapCount		= 0 ;
		MaskBaseImage.GraphDataCount	= 0 ;

		Graphics_Android_BltBmpOrBaseImageToGraph3_NoMipMapBlt(
			&SrcRect,
			&DestRect,
			MASKANDR.MaskImageTextureBuffer,
			1,
			MASKANDR.MaskTextureSizeX,
			MASKANDR.MaskTextureSizeY,
			MASKANDR.MaskTextureSizeX,
			MASKANDR.MaskTextureSizeY,
			&MaskBaseImage,
			&AlphaBaseImage,
			GANDR.Device.Caps.MaskAlphaFormat,
			FALSE,
			FALSE,
			0,
			FALSE
		) ;
	}

	return 0 ;
}

// ẅ̃}XNC[WeNX`XV
extern	int			Mask_UpdateMaskImageTexture_PF( RECT *Rect )
{
//	int i ;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// `I
	Graphics_Android_RenderEnd() ;

	// }XNpC[W̓]
	{
		BASEIMAGE MaskBaseImage ;
		BASEIMAGE AlphaBaseImage ;

		_MEMSET( &AlphaBaseImage, 0, sizeof( AlphaBaseImage ) ) ;
		MaskBaseImage.ColorData			= *Graphics_Android_GetDataFormatColorData( GANDR.Device.Caps.MaskAlphaFormat ) ;
		MaskBaseImage.Width				= MASKANDR.MaskTextureSizeX ;
		MaskBaseImage.Height			= MASKANDR.MaskTextureSizeY ;
		MaskBaseImage.Pitch				= MASKD.MaskBufferPitch ;
		MaskBaseImage.GraphData			= MASKD.MaskBuffer ;
		MaskBaseImage.MipMapCount		= 0 ;
		MaskBaseImage.GraphDataCount	= 0 ;

		Graphics_Android_BltBmpOrBaseImageToGraph3_NoMipMapBlt(
			Rect,
			Rect,
			MASKANDR.MaskImageTextureBuffer,
			1,
			MASKANDR.MaskTextureSizeX,
			MASKANDR.MaskTextureSizeY,
			MASKANDR.MaskTextureSizeX,
			MASKANDR.MaskTextureSizeY,
			&MaskBaseImage,
			&AlphaBaseImage,
			GANDR.Device.Caps.MaskAlphaFormat,
			FALSE,
			FALSE,
			0,
			FALSE
		) ;
	}

	return 0 ;
}






#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_NON_MASK
