//-----------------------------------------------------------------------------
// 
// 		cwCu		WindowspOvO
// 
//  	Ver 3.18c
// 
//-----------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

#include "../DxCompileConfig.h"

// CN[h ---------------------------------------------------------------
#include "DxLogWin.h"

#ifndef DX_NON_LOG

#include "../DxStatic.h"
#include "../DxLib.h"
#include "../DxLog.h"
#include "../DxBaseFunc.h"
#include "../DxMemory.h"
#include "../DxGraphics.h"
#include "DxWindow.h"
#include "DxWinAPI.h"
#include "DxGraphicsWin.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` -----------------------------------------------------------------

// \̐錾 -----------------------------------------------------------------

// f[^` -----------------------------------------------------------------

// ֐錾 -------------------------------------------------------------------

// vO -----------------------------------------------------------------

// Ot@C鏈̊ˑ
extern int LogFileInitialize_PF( const wchar_t *LogFilePath )
{
	HANDLE fp ;

	// G[Ot@Cč쐬
	DeleteFileW( LogFilePath ) ;
	fp = CreateFileW( LogFilePath, GENERIC_WRITE, 0, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL ) ;

	BYTE BOM[ 2 ] = { 0xff, 0xfe } ;
	DWORD WriteSize ;
	WriteFile( fp, &BOM, 2, &WriteSize, NULL ) ;

	if( fp != NULL )
	{
		CloseHandle( fp ) ;
	}

	// I
	return 0 ;
}

// Ot@C֕o̊ˑ
extern int LogFileAdd_WCHAR_T_PF( const wchar_t *LogFilePath, const wchar_t *ErrorStr )
{
	HANDLE	fp ;
	DWORD	WriteSize ;

	if( WinAPIData.Win32Func.WinMMDLL == NULL )
	{
		LoadWinAPI() ;
		if( WinAPIData.Win32Func.WinMMDLL == NULL )
		{
			return -1 ;
		}
	}

	// G[Ot@CJ
	fp = CreateFileW( LogFilePath, GENERIC_WRITE, 0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL ) ;
	if( fp != NULL )
	{
		// t@CANZXʒut@C̖[Ɉړ
		SetFilePointer( fp, 0, NULL, FILE_END ) ;

		// G[Ot@Cɏo
		WriteFile( fp, ErrorStr, ( DWORD )( _WCSLEN( ErrorStr ) * sizeof( wchar_t ) ), &WriteSize, NULL ) ;

		// G[OAEgvbgɏo
		OutputDebugStringW( ErrorStr ) ;

		// t@C
		CloseHandle( fp ) ;
	}
	
	// I
	return 0 ;
}

// O@\̏sǂ擾
extern int IsInitializeLog( void )
{
	if( WinData.MainWindow == NULL )
	{
		return FALSE ;
	}

#ifndef DX_NON_GRAPHICS
	// n[hEGA@\gĂ邩ǂŏ𕪊
	if( GSYS.Setting.ValidHardware )
	{
		switch( GRAWIN.Setting.UseGraphicsAPI )
		{
#ifndef DX_NON_DIRECT3D11
		case GRAPHICS_API_DIRECT3D11_WIN32 :
			return D3D11Device_IsValid() ? TRUE : FALSE ;
#endif // DX_NON_DIRECT3D11

#ifndef DX_NON_DIRECT3D9
		case GRAPHICS_API_DIRECT3D9_WIN32 :
			return NS_GetUseDDrawObj() == NULL ? FALSE : TRUE ;
#endif // DX_NON_DIRECT3D9

		default :
			return FALSE ;
		}
	}
	else
	{
		// cwCuIԂɓĂ珉Ȃ
		return NS_GetUseDDrawObj() == NULL || WinData.MainWindow == NULL ? FALSE : TRUE ;
	}
#else // DX_NON_GRAPHICS
	// cwCuIԂɓĂ珉Ȃ
	return WinData.MainWindow == NULL ? FALSE : TRUE ;
#endif // DX_NON_GRAPHICS

	return TRUE ;
}


#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_NON_LOG

